var http = require('http')
var qs = require('querystring')
var crypto = require('crypto')
var url = require('url')

function http_proxy(ak_id, ak_secret) {
    this.ak_id = ak_id;
    this.ak_secret = ak_secret;

    this.current_gmt_time = function() {
        return new Date().toGMTString();
    };

    this.md5_base64 = function(strbody) {
        let md5hash = crypto.createHash('md5');
        md5hash.update(strbody);
        return md5hash.digest().toString('base64');
    };

    this.sha1_base64 = function(str_to_sign) {
        return crypto.createHmac('sha1', this.ak_secret).update(str_to_sign).digest().toString('base64');
    };

    this.send_request = function(queryurl, body) {
        let gmtnow = this.current_gmt_time();
        let jsonbody = JSON.stringify(body);
        let body_md5 = this.md5_base64(jsonbody);
        let str_to_sign = "POST\napplication/json\n" + body_md5 + "\napplication/json\n" + gmtnow;
        let signature = this.sha1_base64(str_to_sign, this.ak_secret);
        let auth_header = "Dataplus " + ak_id + ":" + signature;

        urldata = url.parse(queryurl);

        let options = {
            host: urldata.host,
            path: urldata.path,
            port: 80,
            method: 'POST',
            headers : {
                'Accept' : 'application/json',
                'Content-Type' : 'application/json',
                'Date': gmtnow,
                'Authorization': auth_header
            }
        };

        let req = http.request(options, function(res) {
            console.log('STATUS: ' + res.statusCode);
            res.setEncoding('utf8')
            res.on('data', function(chunk) {
                console.log('BODY: ' + chunk);
            })
        });

        req.on('error', function(e) {
            console.log('problem with request:' + e.message);
        });

        req.write(jsonbody);
        req.end();
    }
}

module.exports = http_proxy;
